--- util-linux-2.11r/mount/umount.c.sopwith	Thu Jun 27 09:38:36 2002
+++ util-linux-2.11r/mount/umount.c	Thu Jun 27 09:39:10 2002
@@ -543,6 +543,8 @@
 		printf(_("Could not find %s in mtab\n"), file);
 
 	if (suid) {
+		char *mtab_user = NULL;
+
 		if (!mc)
 			die (2, _("umount: %s is not mounted (according to mtab)"), file);
 		if (getmntfilesbackward (file, mc))
@@ -586,7 +588,6 @@
 
 		if (!ok && (fstab_has_user || fstab_has_owner)) {
 			char *user = getusername();
-			char *mtab_user;
 
 			options = parse_list (mc->m.mnt_opts);
 			mtab_user = get_value(options, "user=");
@@ -594,9 +595,14 @@
 			if (user && mtab_user && streq (user, mtab_user))
 				ok = 1;
 		}
-		if (!ok)
+		if (!ok) {
+		    if (mtab_user)
+			die (2, _("umount: only %s can unmount %s from %s"),
+			     mtab_user, fs->m.mnt_fsname, fs->m.mnt_dir);
+		    else
 			die (2, _("umount: only root can unmount %s from %s"),
 			     fs->m.mnt_fsname, fs->m.mnt_dir);
+		}
 	}
 
 	if (mc)
